//
//	test the rgs background server
//
#include <iostream>
#include <cmath>
#include "CalServer.h"
#include "Xmm.h"
#include "RgsBackgroundServer.h"

using namespace std;

static void process(XmmInstrument &rgsunit, unsigned inorder)
{
	cerr<<"Instrument: "<<Xmm::toString(rgsunit.id())<<endl;
	cerr<<"Order: "<<inorder<<endl;
	calServer.setInstrument(rgsunit.id());

	RgsBackgroundServer *rbs = 0; rbs = calServer.getAtom(rbs);

 // Set the order to 1 and find the corresponding number of levels
  unsigned nlevel = rbs->order(inorder).numberExtensions();

	for (unsigned l = 0; l<nlevel; ++l) {
        double expos = rbs->level(l).exposure();
        double level = rbs->level(l).bckgndLevel();
  		vector<int16> channel = rbs->level(l).channel();
  		vector<int> counts = rbs->level(l).counts();
        vector<int16> quality = rbs->level(l).quality();
        vector<float> areascal = rbs->level(l).areascal();
        vector<float> backscal = rbs->level(l).backscal();

		cout<<"Level,expos,chan(1271),counts(1271),qual[40],area(1271), bckscal(1271): "
            <<level<<" "<<expos<<" "<<channel[1271]<<" "<<counts[1271]
            <<" "<<quality[40]<<" "<<areascal[1271]<<" "<<backscal[1271]<<endl;
    }
}

int main()
{
	process(xmmPayLoad.rgs1,1);
	process(xmmPayLoad.rgs2,2);

	return 0;
}

